//
// File:        FComplexLiteral.java
// Package:     gov.llnl.babel.ast
// Copyright:   (c) 2006 The Regents of the University of California
// Release:     $Name$
// Revision:    @(#) $Revision: 5332 $
// Date:        $Date: 2006-04-03 12:25:47 -0700 (Mon, 03 Apr 2006) $
// Description: Hold a dcomplex literal
// 
package gov.llnl.babel.ast;
import gov.llnl.babel.parsers.sidl2.ParseTreeNode;
import gov.llnl.babel.visitor.Visitor;

public class FComplexLiteral extends NumericLiteral {
  private float d_real = 0;
  private float d_imag = 0;


  public FComplexLiteral(ParseTreeNode src, ASTNode parent) {
    super(src,parent);
  }

  public FComplexLiteral() {
    super(null, null);
  }

  public float getReal() {
    return d_real;
  }

  public FloatLiteral getRealLiteral() {
    if (d_src != null) {
      return new FloatLiteral((ParseTreeNode)d_src.jjtGetChild(0), null);
    }
    else {
      FloatLiteral lit = new FloatLiteral();
      lit.setFloat(d_real);
      return lit;
    }
  }
  
  public float getImag() {
    return d_imag;
  }

  public FloatLiteral getImagLiteral() {
    if (d_src != null) {
      return new FloatLiteral((ParseTreeNode)d_src.jjtGetChild(1), null);
    }
    else {
      FloatLiteral lit = new FloatLiteral();
      lit.setFloat(d_imag);
      return lit;
    }
  }
  
  public void setComplex(float real, float imag) {
    d_real = real;
    d_imag = imag;
  }

  public String toString()
  {
    return "{ " + Float.toString(d_real) + "f, " 
      + Float.toString(d_imag) + "f }";
  }

  public Object accept(Visitor v, Object data)
  {
    return v.visitFComplexLiteral(this, data);
  }
}
