//
// File:        TypeResolverList.java
// Package:     gov.llnl.babel.parsers.xml2
// Copyright:   (c) 2006 The Regents of the University of California
// Release:     $Name$
// Revision:    @(#) $Revision: 5295 $
// Date:        $Date: 2006-03-24 14:02:42 -0800 (Fri, 24 Mar 2006) $
// Description: Manage a group of TypeResolvers
// 

package gov.llnl.babel.parsers.xml2;

import gov.llnl.babel.ast.NamedType;
import java.util.Iterator;
import java.util.LinkedList;

public class TypeResolverList extends TypeResolverBase {
  LinkedList d_resolverList = new LinkedList();

  public TypeResolverList() {
    
  }

  void addTypeResolverFront(TypeResolver tr) {
    d_resolverList.addFirst(tr);
  }

  void addTypeResolverLast(TypeResolver tr) {
    d_resolverList.addLast(tr);
  }

  public NamedType lookupType(String name,
                              String version)
    throws UnknownTypeException
  {
    Iterator i = d_resolverList.iterator();
    while (i.hasNext()) {
      TypeResolver tr = (TypeResolver)i.next();
      try {
        return tr.lookupType(name, version);
      }
      catch (UnknownTypeException ute) {
      }
    }
    throw new UnknownTypeException(name, version);
  }
}
