//
// File:        SemanticChecker.java
// Package:     
// Copyright:   (c) 2006 The Regents of the University of California
// Release:     $Name$
// Revision:    @(#) $Revision: 5295 $
// Date:        $Date: 2006-03-24 14:02:42 -0800 (Fri, 24 Mar 2006) $
// Description: This Visitor does a number of semantic checks on the AST. It
// is done last so that the inheritance hierarchy will be fully represented
// in the SymbolTable. 

package gov.llnl.babel.visitor;

import gov.llnl.babel.BabelConfiguration;
import gov.llnl.babel.msg.MsgList;
import gov.llnl.babel.msg.UserMsg;
import gov.llnl.babel.msg.UserMsg2;
import gov.llnl.babel.ast.ASTNode;
import gov.llnl.babel.ast.SIDLFile;
import gov.llnl.babel.ast.ImportClause;
import gov.llnl.babel.ast.RequireClause;
import gov.llnl.babel.ast.ClassType;
import gov.llnl.babel.ast.InterfaceType;
import gov.llnl.babel.ast.Package;
import gov.llnl.babel.ast.ScopedID;
import gov.llnl.babel.ast.Method;
import gov.llnl.babel.ast.Argument;
import gov.llnl.babel.ast.FixedType;
import gov.llnl.babel.ast.ArrayType;
import gov.llnl.babel.ast.RArrayType;
import gov.llnl.babel.ast.Type;
import gov.llnl.babel.ast.Extents;
import gov.llnl.babel.ast.Name;

import java.util.ArrayList;
import java.util.ListIterator;
import java.util.Iterator;
import java.util.HashMap;
import java.util.Vector;
import java.util.LinkedList;
/**
 * Iterates over a AST a second time to decorate a primed SymbolTable
 * with all the details about classes, interfaces, and structs
 * 
 * Type resolution is largely performed in this stage.
 * 
 * @see gov.llnl.babel.visitor.SymbolTablePrimer
 * @author kumfert
 */
public class SemanticChecker extends Visitor {
  
  private final static String SIDL_CLASS
    = "." + BabelConfiguration.getBaseClass();
  
  private final static String SIDL_INTERFACE 
    = "." + BabelConfiguration.getBaseInterface();
  
  protected gov.llnl.babel.symbols.SymbolTable d_st;
  
  protected MsgList d_msgs;

  public SemanticChecker(MsgList msgs) {
    super();
    d_msgs = msgs;
    d_st = gov.llnl.babel.symbols.SymbolTable.getInstance();
  }
  
  public Object visitClassType(ClassType node, Object data) { 
    return data;
  }
}
