/*
 * File:          ExceptionTest_Fib_Impl.c
 * Symbol:        ExceptionTest.Fib-v1.0
 * Symbol Type:   class
 * Babel Version: 0.99.0
 * Description:   Server-side implementation for ExceptionTest.Fib
 * 
 * WARNING: Automatically generated; only changes within splicers preserved
 * 
 */

/*
 * DEVELOPERS ARE EXPECTED TO PROVIDE IMPLEMENTATIONS
 * FOR THE FOLLOWING METHODS BETWEEN SPLICER PAIRS.
 */

/*
 * Symbol "ExceptionTest.Fib" (version 1.0)
 * 
 * This class holds the method <code>getFib</code> that generates the
 * requested Fibonacci numbers.
 */

#include "ExceptionTest_Fib_Impl.h"

#line 26 "../../../../babel_0_99_0_branch/regression/exceptions/libC/ExceptionTest_Fib_Impl.c"
/* DO-NOT-DELETE splicer.begin(ExceptionTest.Fib._includes) */
#include "sidl_Exception.h"
#include "ExceptionTest_NegativeValueException.h"
#include "ExceptionTest_TooDeepException.h"
#include "ExceptionTest_TooBigException.h"
/* DO-NOT-DELETE splicer.end(ExceptionTest.Fib._includes) */
#line 33 "ExceptionTest_Fib_Impl.c"

/*
 * Static class initializer called exactly once before any user-defined method is dispatched
 */

#undef __FUNC__
#define __FUNC__ "impl_ExceptionTest_Fib__load"

#ifdef __cplusplus
extern "C"
#endif
void
impl_ExceptionTest_Fib__load(
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 48 "../../../../babel_0_99_0_branch/regression/exceptions/libC/ExceptionTest_Fib_Impl.c"
  /* DO-NOT-DELETE splicer.begin(ExceptionTest.Fib._load) */
  /* Insert the implementation of the static class initializer method here... */
  /* DO-NOT-DELETE splicer.end(ExceptionTest.Fib._load) */
#line 54 "ExceptionTest_Fib_Impl.c"
}
/*
 * Class constructor called when the class is created.
 */

#undef __FUNC__
#define __FUNC__ "impl_ExceptionTest_Fib__ctor"

#ifdef __cplusplus
extern "C"
#endif
void
impl_ExceptionTest_Fib__ctor(
  /* in */ ExceptionTest_Fib self,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 68 "../../../../babel_0_99_0_branch/regression/exceptions/libC/ExceptionTest_Fib_Impl.c"
  /* DO-NOT-DELETE splicer.begin(ExceptionTest.Fib._ctor) */
  /* nothing needed */
  /* DO-NOT-DELETE splicer.end(ExceptionTest.Fib._ctor) */
#line 76 "ExceptionTest_Fib_Impl.c"
}

/*
 * Special Class constructor called when the user wants to wrap his own private data.
 */

#undef __FUNC__
#define __FUNC__ "impl_ExceptionTest_Fib__ctor2"

#ifdef __cplusplus
extern "C"
#endif
void
impl_ExceptionTest_Fib__ctor2(
  /* in */ ExceptionTest_Fib self,
  /* in */ void* private_data,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 90 "../../../../babel_0_99_0_branch/regression/exceptions/libC/ExceptionTest_Fib_Impl.c"
  /* DO-NOT-DELETE splicer.begin(ExceptionTest.Fib._ctor2) */
  /* Insert-Code-Here {ExceptionTest.Fib._ctor2} (special constructor method) */
  /* DO-NOT-DELETE splicer.end(ExceptionTest.Fib._ctor2) */
#line 100 "ExceptionTest_Fib_Impl.c"
}
/*
 * Class destructor called when the class is deleted.
 */

#undef __FUNC__
#define __FUNC__ "impl_ExceptionTest_Fib__dtor"

#ifdef __cplusplus
extern "C"
#endif
void
impl_ExceptionTest_Fib__dtor(
  /* in */ ExceptionTest_Fib self,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 110 "../../../../babel_0_99_0_branch/regression/exceptions/libC/ExceptionTest_Fib_Impl.c"
  /* DO-NOT-DELETE splicer.begin(ExceptionTest.Fib._dtor) */
  /* nothing needed */
  /* DO-NOT-DELETE splicer.end(ExceptionTest.Fib._dtor) */
#line 122 "ExceptionTest_Fib_Impl.c"
}

/*
 * <p>
 * Generate the requested Fibonacci number or generate exceptions if
 * the input Fibonacci number is invalid or if any of the maximum depth
 * or maximum value parameters are exceeded.  The last argument of the
 * method should be zero.
 * </p>
 * <p>
 * The algorithm should be similar to the <code>Java</code> code below.
 * </p>
 * <pre>
 * public int getFib(int n, int max_depth, int max_value, int depth)
 * throws NegativeValueException, FibException {
 * 
 * if (n < 0) {
 * throw new NegativeValueException("n negative");
 * 
 * } else if (depth > max_depth) {
 * throw new TooDeepException("too deep");
 * 
 * } else if (n == 0) {
 * return 1;
 * 
 * } else if (n == 1) {
 * return 1;
 * 
 * } else {
 * int a = getFib(n-1, max_depth, max_value, depth+1);
 * int b = getFib(n-2, max_depth, max_value, depth+1);
 * if (a + b > max_value) {
 * throw new TooBigException("too big");
 * }
 * return a + b;
 * }
 * } 
 * </pre>
 */

#undef __FUNC__
#define __FUNC__ "impl_ExceptionTest_Fib_getFib"

#ifdef __cplusplus
extern "C"
#endif
int32_t
impl_ExceptionTest_Fib_getFib(
  /* in */ ExceptionTest_Fib self,
  /* in */ int32_t n,
  /* in */ int32_t max_depth,
  /* in */ int32_t max_value,
  /* in */ int32_t depth,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 169 "../../../../babel_0_99_0_branch/regression/exceptions/libC/ExceptionTest_Fib_Impl.c"
  /* DO-NOT-DELETE splicer.begin(ExceptionTest.Fib.getFib) */
  int32_t a;
  int32_t b;
  int32_t theValue = 0;

  if (n < 0) {
    SIDL_THROW(*_ex,
               ExceptionTest_NegativeValueException,
               "called with negative n");
  } else if (depth > max_depth) {
    SIDL_THROW(*_ex,
               ExceptionTest_TooDeepException,
               "exceeded specified recursion depth");
  } else if (n == 0) {
    theValue = 1;
  } else if (n == 1) {
    theValue = 1;
  } else {
    a = impl_ExceptionTest_Fib_getFib(
      self,
      n-1,
      max_depth,
      max_value, 
      depth+1,
      _ex); SIDL_CHECK(*_ex);
    b = impl_ExceptionTest_Fib_getFib(
      self,
      n-2,
      max_depth,
      max_value, 
      depth+1,
      _ex); SIDL_CHECK(*_ex);
    theValue = a + b;
    if (theValue > max_value) {
      /* Reset the value since returning an exception */
      theValue = 0;
      SIDL_THROW(*_ex,
                 ExceptionTest_TooBigException,
                 "result exceeds specified maximum value");
    }
  }

  EXIT:;
    return theValue;
  /* DO-NOT-DELETE splicer.end(ExceptionTest.Fib.getFib) */
#line 225 "ExceptionTest_Fib_Impl.c"
}
/* Babel internal methods, Users should not edit below this line. */
struct ExceptionTest_Fib__object* 
  impl_ExceptionTest_Fib_fconnect_ExceptionTest_Fib(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return ExceptionTest_Fib__connectI(url, ar, _ex);
}
struct ExceptionTest_Fib__object* 
  impl_ExceptionTest_Fib_fcast_ExceptionTest_Fib(void* bi,
  sidl_BaseInterface* _ex) {
  return ExceptionTest_Fib__cast(bi, _ex);
}
struct ExceptionTest_FibException__object* 
  impl_ExceptionTest_Fib_fconnect_ExceptionTest_FibException(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return ExceptionTest_FibException__connectI(url, ar, _ex);
}
struct ExceptionTest_FibException__object* 
  impl_ExceptionTest_Fib_fcast_ExceptionTest_FibException(void* bi,
  sidl_BaseInterface* _ex) {
  return ExceptionTest_FibException__cast(bi, _ex);
}
struct ExceptionTest_NegativeValueException__object* 
  impl_ExceptionTest_Fib_fconnect_ExceptionTest_NegativeValueException(const 
  char* url, sidl_bool ar, sidl_BaseInterface *_ex) {
  return ExceptionTest_NegativeValueException__connectI(url, ar, _ex);
}
struct ExceptionTest_NegativeValueException__object* 
  impl_ExceptionTest_Fib_fcast_ExceptionTest_NegativeValueException(void* bi,
  sidl_BaseInterface* _ex) {
  return ExceptionTest_NegativeValueException__cast(bi, _ex);
}
struct sidl_BaseClass__object* 
  impl_ExceptionTest_Fib_fconnect_sidl_BaseClass(const char* url, sidl_bool ar,
  sidl_BaseInterface *_ex) {
  return sidl_BaseClass__connectI(url, ar, _ex);
}
struct sidl_BaseClass__object* 
  impl_ExceptionTest_Fib_fcast_sidl_BaseClass(void* bi,
  sidl_BaseInterface* _ex) {
  return sidl_BaseClass__cast(bi, _ex);
}
struct sidl_BaseInterface__object* 
  impl_ExceptionTest_Fib_fconnect_sidl_BaseInterface(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sidl_BaseInterface__connectI(url, ar, _ex);
}
struct sidl_BaseInterface__object* 
  impl_ExceptionTest_Fib_fcast_sidl_BaseInterface(void* bi,
  sidl_BaseInterface* _ex) {
  return sidl_BaseInterface__cast(bi, _ex);
}
struct sidl_ClassInfo__object* 
  impl_ExceptionTest_Fib_fconnect_sidl_ClassInfo(const char* url, sidl_bool ar,
  sidl_BaseInterface *_ex) {
  return sidl_ClassInfo__connectI(url, ar, _ex);
}
struct sidl_ClassInfo__object* 
  impl_ExceptionTest_Fib_fcast_sidl_ClassInfo(void* bi,
  sidl_BaseInterface* _ex) {
  return sidl_ClassInfo__cast(bi, _ex);
}
struct sidl_RuntimeException__object* 
  impl_ExceptionTest_Fib_fconnect_sidl_RuntimeException(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sidl_RuntimeException__connectI(url, ar, _ex);
}
struct sidl_RuntimeException__object* 
  impl_ExceptionTest_Fib_fcast_sidl_RuntimeException(void* bi,
  sidl_BaseInterface* _ex) {
  return sidl_RuntimeException__cast(bi, _ex);
}
