/*
 * File:          sort_SortingAlgorithm_Impl.c
 * Symbol:        sort.SortingAlgorithm-v0.1
 * Symbol Type:   class
 * Babel Version: 0.99.0
 * Description:   Server-side implementation for sort.SortingAlgorithm
 * 
 * WARNING: Automatically generated; only changes within splicers preserved
 * 
 */

/*
 * DEVELOPERS ARE EXPECTED TO PROVIDE IMPLEMENTATIONS
 * FOR THE FOLLOWING METHODS BETWEEN SPLICER PAIRS.
 */

/*
 * Symbol "sort.SortingAlgorithm" (version 0.1)
 * 
 * An abstract sorting algorithm.
 */

#include "sort_SortingAlgorithm_Impl.h"

#line 25 "../../../../babel_0_99_0_branch/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
/* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm._includes) */
#include <stdlib.h>
#include "sort_SimpleCounter.h"
#include "sidl_Exception.h"
/* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm._includes) */
#line 31 "sort_SortingAlgorithm_Impl.c"

/*
 * Static class initializer called exactly once before any user-defined method is dispatched
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_SortingAlgorithm__load"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_SortingAlgorithm__load(
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 46 "../../../../babel_0_99_0_branch/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm._load) */
  /* Insert the implementation of the static class initializer method here... */
  /* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm._load) */
#line 52 "sort_SortingAlgorithm_Impl.c"
}
/*
 * Class constructor called when the class is created.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_SortingAlgorithm__ctor"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_SortingAlgorithm__ctor(
  /* in */ sort_SortingAlgorithm self,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 66 "../../../../babel_0_99_0_branch/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm._ctor) */
  struct sort_SortingAlgorithm__data *dptr = 
    malloc(sizeof(struct sort_SortingAlgorithm__data ));
  if (dptr) {
    sort_SimpleCounter sc;
    dptr->d_swp = NULL;
    dptr->d_cmp = NULL;
    sc = sort_SimpleCounter__create(_ex); SIDL_CHECK(*_ex);
    dptr->d_swp = sort_Counter__cast(sc, _ex); SIDL_CHECK(*_ex);
    sort_SimpleCounter_deleteRef(sc, _ex); SIDL_CHECK(*_ex);
    sc = sort_SimpleCounter__create(_ex); SIDL_CHECK(*_ex);
    dptr->d_cmp = sort_Counter__cast(sc, _ex); SIDL_CHECK(*_ex);
    sort_SimpleCounter_deleteRef(sc, _ex); SIDL_CHECK(*_ex);
  }
  sort_SortingAlgorithm__set_data(self, dptr);
  return;
 EXIT:
  {
    sidl_BaseInterface throwaway_exception;
    if (dptr) {
      if (dptr->d_swp)
        sort_Counter_deleteRef(dptr->d_swp, &throwaway_exception);
      if (dptr->d_cmp)
        sort_Counter_deleteRef(dptr->d_cmp, &throwaway_exception);
      free(dptr);
    }
  } 
  /* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm._ctor) */
#line 99 "sort_SortingAlgorithm_Impl.c"
}

/*
 * Special Class constructor called when the user wants to wrap his own private data.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_SortingAlgorithm__ctor2"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_SortingAlgorithm__ctor2(
  /* in */ sort_SortingAlgorithm self,
  /* in */ void* private_data,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 113 "../../../../babel_0_99_0_branch/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm._ctor2) */
  /* Insert-Code-Here {sort.SortingAlgorithm._ctor2} (special constructor method) */
  /* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm._ctor2) */
#line 123 "sort_SortingAlgorithm_Impl.c"
}
/*
 * Class destructor called when the class is deleted.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_SortingAlgorithm__dtor"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_SortingAlgorithm__dtor(
  /* in */ sort_SortingAlgorithm self,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 133 "../../../../babel_0_99_0_branch/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm._dtor) */
  sidl_BaseInterface throwaway_exception;
  struct sort_SortingAlgorithm__data *dptr = 
    sort_SortingAlgorithm__get_data(self);
  if (dptr) {
    sort_Counter_deleteRef(dptr->d_swp, &throwaway_exception);
    dptr->d_swp = NULL;
    sort_Counter_deleteRef(dptr->d_cmp, &throwaway_exception);
    dptr->d_cmp = NULL;
    free((void *)dptr);
  }
  /* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm._dtor) */
#line 154 "sort_SortingAlgorithm_Impl.c"
}

/*
 * Return the comparison counter.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_SortingAlgorithm_getCompareCounter"

#ifdef __cplusplus
extern "C"
#endif
sort_Counter
impl_sort_SortingAlgorithm_getCompareCounter(
  /* in */ sort_SortingAlgorithm self,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 163 "../../../../babel_0_99_0_branch/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm.getCompareCounter) */
  struct sort_SortingAlgorithm__data *dptr = 
    sort_SortingAlgorithm__get_data(self);
  sort_Counter result = NULL;
  if (dptr) {
    sort_Counter_addRef(dptr->d_cmp, _ex); SIDL_CHECK(*_ex);
    result = dptr->d_cmp;
  }
 EXIT:
  return result;
  /* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm.getCompareCounter) */
#line 185 "sort_SortingAlgorithm_Impl.c"
}

/*
 * Return the swap counter.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_SortingAlgorithm_getSwapCounter"

#ifdef __cplusplus
extern "C"
#endif
sort_Counter
impl_sort_SortingAlgorithm_getSwapCounter(
  /* in */ sort_SortingAlgorithm self,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 192 "../../../../babel_0_99_0_branch/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm.getSwapCounter) */
  struct sort_SortingAlgorithm__data *dptr = 
    sort_SortingAlgorithm__get_data(self);
  sort_Counter result = NULL;
  if (dptr) {
    sort_Counter_addRef(dptr->d_swp, _ex); SIDL_CHECK(*_ex);
    result = dptr->d_swp;
  }
 EXIT:
  return result;
  /* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm.getSwapCounter) */
#line 216 "sort_SortingAlgorithm_Impl.c"
}

/*
 * Reset the comparison and swap counter.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_SortingAlgorithm_reset"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_SortingAlgorithm_reset(
  /* in */ sort_SortingAlgorithm self,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 221 "../../../../babel_0_99_0_branch/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm.reset) */
  struct sort_SortingAlgorithm__data *dptr = 
    sort_SortingAlgorithm__get_data(self);
  if (dptr) {
    sort_Counter_reset(dptr->d_swp, _ex); SIDL_CHECK(*_ex);
    sort_Counter_reset(dptr->d_cmp, _ex); SIDL_CHECK(*_ex);
  }
 EXIT:;
  /* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm.reset) */
#line 245 "sort_SortingAlgorithm_Impl.c"
}
/* Babel internal methods, Users should not edit below this line. */
struct sidl_BaseClass__object* 
  impl_sort_SortingAlgorithm_fconnect_sidl_BaseClass(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sidl_BaseClass__connectI(url, ar, _ex);
}
struct sidl_BaseClass__object* 
  impl_sort_SortingAlgorithm_fcast_sidl_BaseClass(void* bi,
  sidl_BaseInterface* _ex) {
  return sidl_BaseClass__cast(bi, _ex);
}
struct sidl_BaseInterface__object* 
  impl_sort_SortingAlgorithm_fconnect_sidl_BaseInterface(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sidl_BaseInterface__connectI(url, ar, _ex);
}
struct sidl_BaseInterface__object* 
  impl_sort_SortingAlgorithm_fcast_sidl_BaseInterface(void* bi,
  sidl_BaseInterface* _ex) {
  return sidl_BaseInterface__cast(bi, _ex);
}
struct sidl_ClassInfo__object* 
  impl_sort_SortingAlgorithm_fconnect_sidl_ClassInfo(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sidl_ClassInfo__connectI(url, ar, _ex);
}
struct sidl_ClassInfo__object* 
  impl_sort_SortingAlgorithm_fcast_sidl_ClassInfo(void* bi,
  sidl_BaseInterface* _ex) {
  return sidl_ClassInfo__cast(bi, _ex);
}
struct sidl_RuntimeException__object* 
  impl_sort_SortingAlgorithm_fconnect_sidl_RuntimeException(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sidl_RuntimeException__connectI(url, ar, _ex);
}
struct sidl_RuntimeException__object* 
  impl_sort_SortingAlgorithm_fcast_sidl_RuntimeException(void* bi,
  sidl_BaseInterface* _ex) {
  return sidl_RuntimeException__cast(bi, _ex);
}
struct sort_Comparator__object* 
  impl_sort_SortingAlgorithm_fconnect_sort_Comparator(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sort_Comparator__connectI(url, ar, _ex);
}
struct sort_Comparator__object* 
  impl_sort_SortingAlgorithm_fcast_sort_Comparator(void* bi,
  sidl_BaseInterface* _ex) {
  return sort_Comparator__cast(bi, _ex);
}
struct sort_Container__object* 
  impl_sort_SortingAlgorithm_fconnect_sort_Container(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sort_Container__connectI(url, ar, _ex);
}
struct sort_Container__object* 
  impl_sort_SortingAlgorithm_fcast_sort_Container(void* bi,
  sidl_BaseInterface* _ex) {
  return sort_Container__cast(bi, _ex);
}
struct sort_Counter__object* 
  impl_sort_SortingAlgorithm_fconnect_sort_Counter(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sort_Counter__connectI(url, ar, _ex);
}
struct sort_Counter__object* 
  impl_sort_SortingAlgorithm_fcast_sort_Counter(void* bi,
  sidl_BaseInterface* _ex) {
  return sort_Counter__cast(bi, _ex);
}
struct sort_SortingAlgorithm__object* 
  impl_sort_SortingAlgorithm_fconnect_sort_SortingAlgorithm(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sort_SortingAlgorithm__connectI(url, ar, _ex);
}
struct sort_SortingAlgorithm__object* 
  impl_sort_SortingAlgorithm_fcast_sort_SortingAlgorithm(void* bi,
  sidl_BaseInterface* _ex) {
  return sort_SortingAlgorithm__cast(bi, _ex);
}
